unit com32t;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  kmodbus, StdCtrls, MPlayer, ExtCtrls, kComp, ComCtrls, kbar;

type
  TCommTest = class(TForm)
    GroupBoxModbus: TGroupBox;
    LabelPort: TLabel;
    LabelReg: TLabel;
    Button1: TButton;
    EditReg: TEdit;
    EditWhat: TEdit;
    ButtonRead: TButton;
    EditReadReg: TEdit;
    Button2: TButton;
    Button3: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox1: TGroupBox;
    kTrackBarHz: TkTrackBar;
    CounterHz: TCounter;
    Label2: TLabel;
    Label7: TLabel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ButtonReadClick(Sender: TObject);
    procedure kTrackBarHzChange(Sender: TObject);
    procedure CounterHzClick(Sender: TObject);
    function SetHz(hz:integer):integer;
  private
    { Private declarations }
    Modbus : TModbus;
    slave : integer;
    MaxHz : integer;
  public
    { Public declarations }
  end;

var
  CommTest: TCommTest;

implementation

{$R *.DFM}

procedure TCommTest.FormCreate(Sender: TObject);
begin
  slave := 1;
  Modbus := TModbus.Create(self);
  if ( ParamCount > 0 ) then begin
    Modbus.Port := StrToInt(ParamStr(1));
  end;
  LabelPort.Caption := IntToStr(Modbus.Port);
  Modbus.Open;
  Top := 0;
  Left := 0;
  MaxHz := Modbus.ReadReg(slave,$10C);
  kTrackBarHz.Max := MaxHz;
  kTrackBarHz.Min := -MaxHz;
end;

procedure TCommTest.Button1Click(Sender: TObject);
begin
//  com.EndOfResponse := #13;
  Label1.Caption := '';
  Modbus.SetReg(slave,StrToInt(EditReg.Text),StrToInt(EditWhat.Text));
  Label1.Caption := ModBus.Read;
//  Label1.Caption := Com.Read;
end;

function TimeInMSec:double;
var Hour,Min,Sec,MSec:Word;
begin
  DecodeTime(Time,Hour,Min,Sec,MSec);
  Result := ((Hour*60 + Min)*60+Sec)*1000 + MSec;
end;


procedure TCommTest.Button3Click(Sender: TObject);
var i:integer;
    d : double;
    a : array [0..10000] of double;
begin
//  Label3.Caption := com.ReadOne;
  Label3.Caption := 'Reading';
  i := 0;
  d := TimeInMSec;
  a[0] := d;
  repeat
//    Application.ProcessMessages;
//    Label3.Caption := com.ReadOne;
//    Sleep(0);
    i := i+1;
//    a[i] := TimeInMSec;
  until ( TimeInMSec > d + 1000 );
  Label3.Caption := IntToStr(i);
end;

procedure TCommTest.Button2Click(Sender: TObject);
begin
  Label1.Caption := ModBus.Read;
end;

procedure TCommTest.ButtonReadClick(Sender: TObject);
var v : integer;
begin
  LabelReg.Caption := '';
  v := Modbus.ReadReg(slave,StrToInt(EditReadReg.Text));
  LabelReg.Caption := IntToStr(v);
 end;

function TCommTest.SetHz(hz:integer):integer;
var d:integer;
begin
  d := 0;
  if ( hz < 0 ) then d := 3;
  if ( hz > 0 ) then d := 1;
  Modbus.SetReg2(slave,1,d,Abs(hz));
  hz := Modbus.ReadReg(slave,2);
  if ( d = 3 ) then Hz := -Hz;
  CounterHZ.Value := Hz;
  Result := Hz;
end;

procedure TCommTest.kTrackBarHzChange(Sender: TObject);
begin
  with ( Sender as TkTrackBar ) do begin
    SetHz(Position);
  end;
end;

procedure TCommTest.CounterHzClick(Sender: TObject);
begin
  SetHz(0);
  kTrackBarHz.Position := 0;
end;

end.
