{
  Yaskawan muuttaja:
  Asetukset muuttajassa muuttuvat vain, jos virta kytetn poissa!
    Rekisterien lukeminen (fkt 3): (ks Yaskawan IO-manu p 14/29)
      esim:              11-rekisteri (alk. 101H)
                  id fkt 10B  5-kpl   crc (lo-hi)
        lhet :  01 03 01 0B 00 05   F5 F7

                        rek  011  012   013  014    015
                        mem  10BH 10CH  10DH 10EH   10FH
                  id fkt #  230V,60 Hz, 230V,60 Hz,3.0 Hz,crc
        takaisin: 01 03 0A 08 FC 02 58 08 FC 02 58 00 1E FD 7B

    Jos funktio on vr, tulee takasin vastaus, jossa on
    id, 7-bit pll +fkt nro,  virhekoodi + crc

    Jotta tottelisi ajoksky PC:lt, aseta (fkt 10H) 002:een 6:
                  id fkt 102H lkm=1 tav
        lhet :  01 10 01 02 00 01 02  00 06


}

unit comi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, OleCtrls, MSCOMM32;

type TRsIn = TMemo;

type
  cLueRS = class(TThread)
  // Laskurisie perit.yleisest sikeest
  // ja siihen listn omat erikoispiirt.
  private
    InHex: TRSin;
    InChar: TRSin;
    getcount : integer;
    getsh : string;
    getsc : string;
    FLimit : integer;
    FPause : boolean;
    alku : integer;
    lastalku : integer;
    lastlkm : integer;
    buffer : array [0..2000] of char;
  protected
    procedure ReadRS; //Yhden laskuaskeleen su
    //Perit.luokan Execute korvataan omalla
    procedure Execute; override;
    procedure SetPause(f:boolean);
    procedure ShowString;
  public
    //Rakentaja, joka alustaa mm. sis. muut.
    constructor Create(i,h:TRSin);
    procedure ClearIn;
  published
    property Limit : integer read FLimit write FLimit;
    property Pause : boolean read FPause write SetPause;
  end;


type
  TFormCommTest = class(TForm)
    ButtonDTRon: TButton;
    ButtonDTRoff: TButton;
    ButtonSend: TButton;
    EditSend: TEdit;
    LabelCRC: TLabel;
    GroupBox1: TGroupBox;
    LabelComPort: TLabel;
    LabelIO: TLabel;
    ComboBoxBaud: TComboBox;
    EditIO: TEdit;
    ComboBoxComPort: TComboBox;
    ButtonSet: TButton;
    ButtonHex: TButton;
    EditHex: TEdit;
    ButtonClear: TButton;
    EditLen: TEdit;
    CheckPause: TCheckBox;
    InHex: TMemo;
    InChar: TMemo;
    ButtonCRC: TButton;
    Timer1: TTimer;
    EditPri: TEdit;
    procedure ButtonDTRonClick(Sender: TObject);
    procedure ButtonDTRoffClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ButtonSendClick(Sender: TObject);
    procedure ButtonSetClick(Sender: TObject);
    procedure ComboBoxComPortChange(Sender: TObject);
    procedure ButtonHexClick(Sender: TObject);
    procedure ButtonClearClick(Sender: TObject);
    procedure CheckPauseClick(Sender: TObject);
    procedure ButtonCRCClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    sendchars : array [1..500] of char;
    sendcount : integer;
    LueRS : cLueRS;
    procedure DoSetLine;
    function CountCRC(s:string):string;
    function CountCRCDisp(var s:Array of char; n:integer):integer;
  public
    { Public declarations }
  end;



var
  FormCommTest: TFormCommTest;

implementation

{$R *.DFM}


var BaseAddr : word;
    DivideLatchLSB,
    DivideLatchMSB,
    TransmitBuffer,
    ReceiveBuffer,
    InterruptEnableReg,
    InterruptIdentificationRegister,
    LineControlRegister,
    ModemControlRegister,
    LineStatusRegister,
    ModemStatusRegister : Word;

procedure DTRon; assembler;
asm
  mov dx,ModemControlRegister
  in  al,dx
  or  al,1
  mov al,1
  out dx,al
end;

procedure DTRoff;
asm
  mov dx,ModemControlRegister
  in  al,dx
  and al,$fe
  mov al,0
  out dx,al
end;

procedure TFormCommTest.ButtonDTRonClick(Sender: TObject);
begin
  DTRon;
end;

procedure TFormCommTest.ButtonDTRoffClick(Sender: TObject);
begin
  DTRoff;
end;

procedure SetBase(Base:Word);
begin
  BaseAddr                          := Base;
  DivideLatchLSB                    := Base + 0;
  DivideLatchMSB                    := Base + 1;
  TransmitBuffer                    := Base + 0;
  ReceiveBuffer                     := Base + 0;
  InterruptEnableReg                := Base + 1;
  InterruptIdentificationRegister   := Base + 2;
  LineControlRegister               := Base + 3;
  ModemControlRegister              := Base + 4;
  LineStatusRegister                := Base + 5;
  ModemStatusRegister               := Base + 6;
end;

procedure SetBaud(baud:integer);
asm
// CLI
 MOV  ECX,baud
 MOV  DX,LineControlRegister
 MOV  AL,$80          // divisor latch access on
 OUT  DX,AL
// MOV  DX,$1
 MOV  EAX,$1C200      // (1.8432Mhz/16) = 1C200H
 MOV  EDX,0
 DIV  ECX
 MOV  DX,DivideLatchLSB
 OUT  DX,AL
 MOV  DX,DivideLatchMSB
 MOV  AL,AH
 OUT  DX,AL
 MOV  DX,LineControlRegister                  //  0  0 000 0 11
 MOV  AL,$03            // divisor latch access off +    n,1,8
 OUT  DX,AL

 STI
end;

procedure SendChar(c:char);
label odota_linja_vapaaksi,odota_linja_vapaaksi2;
asm
 MOV  AL,c
 PUSH AX
 MOV  EDX,0
 MOV  DX,LineStatusRegister
odota_linja_vapaaksi:
 IN   AL,DX
 TEST AL,$20                 // THR empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi
 POP  AX
 MOV  DX,TransmitBuffer      // Transmitter holding register
 OUT  DX,AL

 MOV  DX,LineStatusRegister
odota_linja_vapaaksi2:
 IN   AL,DX
 TEST AL,$40                 // TxE empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi2
end;

procedure WaitSend;
label odota_linja_vapaaksi2;
asm
 MOV  EDX,0
 MOV  DX,LineStatusRegister
odota_linja_vapaaksi2:
 IN   AL,DX
 TEST AL,$40                 // TxE empty jos bitti 5 pll
 JZ   odota_linja_vapaaksi2
end;

Function ReadChar : smallint;
Label loppu;
asm
  MOV  AX,-1
  MOV  DX,LineStatusRegister
  IN   AL,DX
  AND  AL,1
  JZ   loppu
  MOV  DX,ReceiveBuffer
  MOV  AX,0
  IN   AL,DX
loppu:
  MOV  Result, AX
end;

procedure SendString(var s:array of char; n:integer);
var i:integer;
begin
  DTRon;
  for i:=0 to n-1 do
    SendChar(s[i]);
  DTRoff;
end;

procedure SetLine(const io,b:string);
var base,baud:integer;
begin
  base := StrToInt('$'+io);
  SetBase(base);
  baud := StrToInt(b);
  SetBaud(baud);
end;

procedure TFormCommTest.DoSetLine;
var base,baud:integer; i:integer;
begin
  SetLine(EditIO.Text,ComboBoxBaud.Text);

  if ( LueRS = NIL ) then LueRS := cLueRS.Create(InChar,InHex);
  LueRS.Limit := StrToIntDef(EditLen.Text,40);
  LueRS.Priority := TThreadPriority(StrToIntDef(EditPri.Text,4));
  LueRS.ClearIn;
end;

procedure TFormCommTest.FormCreate(Sender: TObject);
var p:integer;
begin
  LueRS := NIL;
  ComboBoxBaud.ItemIndex    := 13;  // 9600
  p := 0;
  if ( ParamStr(1) > ' ' ) then p := ORD(ParamStr(1)[1]) - ORD('1');
  ComboBoxComPort.ItemIndex :=  p;  // Com 1
  ComboBoxComPortChange(self);
  DoSetLine;

end;

function crc16_2(puchMsg:PChar;usDataLen:integer):word;
  stdcall; far; external;
{$l crc.obj}

function TFormCommTest.CountCRC(s:string):string;
var  crc : integer;
begin
  crc := crc16_2(PChar(s),Length(s));
  LabelCRC.Caption := Format('%04x',[crc]);
  Result := Char(lo(crc))+Char(hi(crc));
end;

function CountCRCInt(var s:Array of char; n:integer):integer;
var  crc : integer;
begin
  crc := crc16_2(s,n);
  Result := crc;
end;

function TFormCommTest.CountCRCDisp(var s:Array of char; n:integer):integer;
var  crc : integer;
begin
  crc := CountCRCInt(s,n);
  LabelCRC.Caption := Format('%04x',[crc]);
  Result := crc;
end;

procedure TFormCommTest.ButtonSendClick(Sender: TObject);
begin
  CountCRCDisp(SendChars,SendCount);
  SendString(SendChars,SendCount);
  LueRS.ClearIn;
end;

function CharToHex(c:char):string;
begin
  Result := Format('%02x',[Ord(c)]);
  if ( Result[1] = ' ' ) then Result[1] := '0';
end;

procedure TFormCommTest.ButtonSetClick(Sender: TObject);
begin
  DoSetLine;
end;

procedure TFormCommTest.ComboBoxComPortChange(Sender: TObject);
begin
  case ComboBoxComPort.Text[1] of
    '1' : EditIO.Text := '3f8';
    '2' : EditIO.Text := '2f8';
    '3' : EditIO.Text := '3e8';
    '4' : EditIO.Text := '2e8';
  end;
end;

procedure TFormCommTest.ButtonHexClick(Sender: TObject);
var s,r,h:string; crc,len,i:integer;
begin
  s := EditHex.text;
  len := Length(s);
  r := '';
  i := 1;
  sendcount := 0;
  while ( i < len ) do begin
    if ( Pos(s[i],'$ ,;/|') > 0 ) then begin i := i + 1; continue; end;
    h := '$' + s[i] + s[i+1]; i := i + 2;
    r := r + Char(StrToInt(h));
    inc(sendcount); sendchars[sendcount] := Char(StrToInt(h));
  end;
  EditSend.Text := r + CountCrc(r);
  crc := CountCrcInt(sendchars,sendcount);
  inc(sendcount); sendchars[sendcount] := Char(lo(crc));
  inc(sendcount); sendchars[sendcount] := Char(hi(crc));
end;

procedure TFormCommTest.ButtonCRCClick(Sender: TObject);
var s,r,h:string; crc,len,i:integer;
begin
  s := InHex.SelText;
  len := Length(s);
  r := '';
  i := 1;
  sendcount := 0;
  while ( i < len ) do begin
    if ( Pos(s[i],'$ ,;/|') > 0 ) then begin i := i + 1; continue; end;
    h := '$' + s[i] + s[i+1]; i := i + 2;
    r := r + Char(StrToInt(h));
    inc(sendcount); sendchars[sendcount] := Char(StrToInt(h));
  end;
  EditSend.Text := r + CountCrc(r);
  crc := CountCrcInt(sendchars,sendcount);
  inc(sendcount); sendchars[sendcount] := Char(lo(crc));
  inc(sendcount); sendchars[sendcount] := Char(hi(crc));
end;


procedure TFormCommTest.ButtonClearClick(Sender: TObject);
begin
  LueRS.ClearIn;
end;

//-------------------------------------------
// Sie lukemista varten
//-------------------------------------------

//-------------------------------------------
procedure cLueRS.ClearIn;
begin
  InChar.Text := '';
  InHex.Text := '';
  Getsh := '';
  Getsc := '';
  GetCount := 0;
  alku := 0;
  lastalku := -1;
  lastlkm := -1;
end;


//-------------------------------------------
procedure cLueRS.SetPause(f:boolean);
begin
  FPause := f;
//  InChar.Text := getsc;
//  InHex.Text := getsh;
end;

procedure cLueRS.ShowString;
var i,index,lkm :integer; c:char;
begin
  if pause then exit;
  index := alku;
  getsc := '';
  getsh := ' ';
  lkm := limit;
  if ( getcount <= lkm ) then begin lkm := getcount; index := 0; end;
  if ( alku = lastalku ) and ( lkm = lastlkm ) then exit;
  lastalku := alku;
  lastlkm := lkm;
  for i:=0 to lkm-1 do begin
    c := Buffer[index];
    getsc := getsc + c;
    getsh := getsh + CharToHex(c) + ' ';
    inc(index); if index >= limit then index := 0;
    InChar.Text := getsc;
    InHex.Text := getsh;
  end;
end;

//-------------------------------------------
procedure cLueRS.ReadRS;
var i:smallint; c:Char;
begin
  while ( true ) do begin
    i := ReadChar;
    if ( hi(i) <> 0 ) then exit;
    c := Char(lo(i));
    Buffer[alku] := c;
    inc(alku); if ( alku >= limit ) then alku := 0;
    inc(getcount);
  end;
end;

//-------------------------------------------
procedure cLueRS.Execute;
// Tm suorittaa varsinaisen sikeen
// toimenpiteet.  Kun tm metodi loppuu,
// pyshtyy sie.  Sie hvi autom.
// jos FreeOnTerminate := True
begin
  while ( true ) do begin
    if terminated then begin
      Break;
    end;
    ReadRS;
  end;
end;

//-------------------------------------------
constructor cLueRS.Create(i,h:TRsIn);
begin
  inherited Create(False);
  FLimit := 50;
  InChar := i;
  InHex  := h;
  FreeOnTerminate := True;
  pause := false;
  ClearIn;
  Priority  := tpLower;
end;

procedure TFormCommTest.CheckPauseClick(Sender: TObject);
begin
  LueRS.Pause := CheckPause.Checked;
end;


procedure TFormCommTest.Timer1Timer(Sender: TObject);
begin
  LueRS.ShowString;
end;

end.
